package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales.cyberviaje;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
import com.rjconsultores.ventaboletos.entidad.ProdMarca;
import com.rjconsultores.ventaboletos.entidad.ProductoServicio;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.ProductoServicioService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Listcell;
import org.zkoss.zul.Listitem;
import org.zkoss.zul.ListitemRenderer;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Rafius
 */
@Controller("busquedaProductoServicioController")
@Scope("prototype")
public class BusquedaProductoServicioController extends MyGenericForwardComposer
        implements ListitemRenderer {

    @Autowired
    private transient PagedListWrapper<ProductoServicio> plwProductoServicio;
    @Autowired
    private ProductoServicioService productoServicioService;
    @Autowired
    private EmpresaService empresaService;
    private MyListbox productoServicioList;
    private Paging pagingProductoServicio;
    private List<ProductoServicio> lsProductoServicio;
    private Textbox txtNome;

    @Override
    public void doAfterCompose(Component comp) throws Exception {

        super.doAfterCompose(comp);

        productoServicioList.setItemRenderer(this);
        productoServicioList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                ProductoServicio productoServicio = (ProductoServicio) productoServicioList.getSelected();
                verProductoServicio(productoServicio);
            }
        });

        lsProductoServicio = new ArrayList<ProductoServicio>();

        refreshLista();
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verProductoServicio(new ProductoServicio());
    }

    private void refreshLista() {
        HibernateSearchObject<ProductoServicio> productoServicioSearch =
                new HibernateSearchObject<ProductoServicio>(ProductoServicio.class, pagingProductoServicio.getPageSize());

        if (!txtNome.getValue().equals("")) {
            productoServicioSearch.addFilterILike("descproductoservicio", "%" + txtNome.getValue() + "%");
        }

        productoServicioSearch.addFilterEqual("activo", Boolean.TRUE);

        productoServicioSearch.addFilterEqual("indtipo", "S");

        productoServicioSearch.addSortAsc("descproductoservicio");

        plwProductoServicio.init(productoServicioSearch, productoServicioList, pagingProductoServicio);

        if (productoServicioList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaProductoServicioController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    private void verProductoServicio(ProductoServicio productoServicio) {
        if (productoServicio == null) {
            return;
        }

        Map args = new HashMap();
        args.put("productoServicio", productoServicio);
        args.put("productoServicioList", productoServicioList);

        openWindow("/gui/configuraciones_comerciales/cyberviaje/editarProductoServicio.zul",
                Labels.getLabel("editarProductoServicioController.window.title"), args, MODAL);
    }

    public List<ProductoServicio> getLsProductoServicio() {
        return lsProductoServicio;
    }

    public void setLsProductoServicio(List<ProductoServicio> lsProductoServicio) {
        this.lsProductoServicio = lsProductoServicio;
    }

    public Paging getPagingProductoServicio() {
        return pagingProductoServicio;
    }

    public void setPagingProductoServicio(Paging pagingProductoServicio) {
        this.pagingProductoServicio = pagingProductoServicio;
    }

    public PagedListWrapper<ProductoServicio> getPlwProductoServicioPunto() {
        return plwProductoServicio;
    }

    public void setPlwProductoServicioPunto(PagedListWrapper<ProductoServicio> plwProductoServicioPunto) {
        this.plwProductoServicio = plwProductoServicioPunto;
    }

    public MyListbox getProductoServicioList() {
        return productoServicioList;
    }

    public void setProductoServicioList(MyListbox productoServicioList) {
        this.productoServicioList = productoServicioList;
    }

    public ProductoServicioService getProductoServicioService() {
        return productoServicioService;
    }

    public void setProductoServicioService(ProductoServicioService productoServicioService) {
        this.productoServicioService = productoServicioService;
    }

    public EmpresaService getEmpresaService() {
        return empresaService;
    }

    public void setEmpresaService(EmpresaService empresaService) {
        this.empresaService = empresaService;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    public void render(Listitem lstm, Object o) throws Exception {
        ProductoServicio p = (ProductoServicio) o;
        p = productoServicioService.obtenerID(p.getProductoservicioId());

        Listcell lc = new Listcell();

        lc = new Listcell(p.getProductoservicioId().toString());
        lc.setParent(lstm);

        if (p.getDescproductoservicio() != null) {
            lc = new Listcell(p.getDescproductoservicio());
        } else {
            lc = new Listcell("-");
        }
        lc.setParent(lstm);

        lstm.setAttribute("data", p);
    }
}
